Index: uspace/drv/bus/usb/uhci/pci.c
===================================================================
--- uspace/drv/bus/usb/uhci/pci.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/uhci/pci.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -82,6 +82,5 @@
 	bool irq_found = false;
 
-	size_t i;
-	for (i = 0; i < hw_resources.count; i++) {
+	for (size_t i = 0; i < hw_resources.count; i++) {
 		const hw_resource_t *res = &hw_resources.resources[i];
 		switch (res->type) {
Index: uspace/drv/bus/usb/uhci/uhci.c
===================================================================
--- uspace/drv/bus/usb/uhci/uhci.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/uhci/uhci.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -89,29 +89,4 @@
 };
 /*----------------------------------------------------------------------------*/
-/** Get address of the device identified by handle.
- *
- * @param[in] fun DDF instance of the function to use.
- * @param[in] handle DDF handle of the driver seeking its USB address.
- * @param[out] address Found address.
- */
-static int usb_iface_get_address(
-    ddf_fun_t *fun, devman_handle_t handle, usb_address_t *address)
-{
-	assert(fun);
-	usb_device_manager_t *manager =
-	    &dev_to_uhci(fun->dev)->hc.generic.dev_manager;
-	const usb_address_t addr = usb_device_manager_find(manager, handle);
-
-	if (addr < 0) {
-		return addr;
-	}
-
-	if (address != NULL) {
-		*address = addr;
-	}
-
-	return EOK;
-}
-/*----------------------------------------------------------------------------*/
 /** Gets handle of the respective hc.
  *
@@ -134,5 +109,4 @@
 static usb_iface_t usb_iface = {
 	.get_hc_handle = usb_iface_get_hc_handle,
-	.get_address = usb_iface_get_address
 };
 /*----------------------------------------------------------------------------*/
Index: uspace/drv/bus/usb/uhci/uhci.ma
===================================================================
--- uspace/drv/bus/usb/uhci/uhci.ma	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/uhci/uhci.ma	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -1,29 +1,1 @@
-10 pci/ven=8086&dev=7020
-10 pci/ven=8086&dev=7112
-
-10 pci/ven=8086&dev=27c8
-10 pci/ven=8086&dev=27c9
-10 pci/ven=8086&dev=27ca
-10 pci/ven=8086&dev=27cb
-
-10 pci/ven=8086&dev=2830
-10 pci/ven=8086&dev=2831
-10 pci/ven=8086&dev=2832
-10 pci/ven=8086&dev=2834
-10 pci/ven=8086&dev=2835
-
-10 pci/ven=8086&dev=2934
-10 pci/ven=8086&dev=2935
-10 pci/ven=8086&dev=2936
-10 pci/ven=8086&dev=2937
-10 pci/ven=8086&dev=2938
-10 pci/ven=8086&dev=2939
-
-10 pci/ven=8086&dev=24c2
-10 pci/ven=8086&dev=24c4
-10 pci/ven=8086&dev=24c7
-
-10 pci/ven=8086&dev=2688
-10 pci/ven=8086&dev=2689
-10 pci/ven=8086&dev=268a
-10 pci/ven=8086&dev=268b
+10 pci/class=0c&subclass=03&progif=00
Index: uspace/drv/bus/usb/uhci/uhci_batch.c
===================================================================
--- uspace/drv/bus/usb/uhci/uhci_batch.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/uhci/uhci_batch.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -48,5 +48,5 @@
 {
 	if (uhci_batch) {
-		usb_transfer_batch_dispose(uhci_batch->usb_batch);
+		usb_transfer_batch_destroy(uhci_batch->usb_batch);
 		free32(uhci_batch->device_buffer);
 		free(uhci_batch);
@@ -167,6 +167,6 @@
 	    uhci_batch->td_count);
 	uhci_batch->usb_batch->transfered_size = 0;
-	size_t i = 0;
-	for (;i < uhci_batch->td_count; ++i) {
+
+	for (size_t i = 0;i < uhci_batch->td_count; ++i) {
 		if (td_is_active(&uhci_batch->tds[i])) {
 			return false;
Index: uspace/drv/bus/usb/uhci/utils/malloc32.h
===================================================================
--- uspace/drv/bus/usb/uhci/utils/malloc32.h	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/uhci/utils/malloc32.h	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -62,10 +62,11 @@
 }
 /*----------------------------------------------------------------------------*/
-/** Physical mallocator simulator
+/** DMA malloc simulator
  *
  * @param[in] size Size of the required memory space
- * @return Address of the alligned and big enough memory place, NULL on failure.
+ * @return Address of the aligned and big enough memory place, NULL on failure.
  */
-static inline void * malloc32(size_t size) {
+static inline void * malloc32(size_t size)
+{
 	/* This works only when the host has less than 4GB of memory as
 	 * physical address needs to fit into 32 bits */
@@ -83,13 +84,10 @@
 }
 /*----------------------------------------------------------------------------*/
-/** Physical mallocator simulator
+/** DMA malloc simulator
  *
  * @param[in] addr Address of the place allocated by malloc32
  */
-static inline void free32(void *addr) {
-	if (!addr)
-		return;
-	free(addr);
-}
+static inline void free32(void *addr)
+	{ free(addr); }
 /*----------------------------------------------------------------------------*/
 /** Create 4KB page mapping
Index: uspace/drv/bus/usb/uhcirh/main.c
===================================================================
--- uspace/drv/bus/usb/uhcirh/main.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/uhcirh/main.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -51,8 +51,8 @@
     uintptr_t *io_reg_address, size_t *io_reg_size);
 
-static int uhci_rh_add_device(ddf_dev_t *device);
+static int uhci_rh_dev_add(ddf_dev_t *device);
 
 static driver_ops_t uhci_rh_driver_ops = {
-	.add_device = uhci_rh_add_device,
+	.dev_add = uhci_rh_dev_add,
 };
 
@@ -82,10 +82,10 @@
  * @return Error code.
  */
-static int uhci_rh_add_device(ddf_dev_t *device)
+static int uhci_rh_dev_add(ddf_dev_t *device)
 {
 	if (!device)
 		return EINVAL;
 
-	usb_log_debug2("uhci_rh_add_device(handle=%" PRIun ")\n",
+	usb_log_debug2("uhci_rh_dev_add(handle=%" PRIun ")\n",
 	    device->handle);
 
Index: uspace/drv/bus/usb/uhcirh/port.c
===================================================================
--- uspace/drv/bus/usb/uhcirh/port.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/uhcirh/port.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -37,13 +37,15 @@
 #include <str_error.h>
 #include <async.h>
+#include <devman.h>
 
 #include <usb/usb.h>    /* usb_address_t */
-#include <usb/dev/hub.h>    /* usb_hc_new_device_wrapper */
 #include <usb/debug.h>
 
 #include "port.h"
 
+#define MAX_ERROR_COUNT 5
+
 static int uhci_port_check(void *port);
-static int uhci_port_reset_enable(int portno, void *arg);
+static int uhci_port_reset_enable(void *arg);
 static int uhci_port_new_device(uhci_port_t *port, usb_speed_t speed);
 static int uhci_port_remove_device(uhci_port_t *port);
@@ -100,5 +102,6 @@
 	port->number = number;
 	port->wait_period_usec = usec;
-	port->attached_device = 0;
+	port->attached_device.fun = NULL;
+	port->attached_device.address = -1;
 	port->rh = rh;
 
@@ -150,4 +153,17 @@
 	assert(instance);
 
+	unsigned allowed_failures = MAX_ERROR_COUNT;
+#define CHECK_RET_FAIL(ret, msg...) \
+	if (ret != EOK) { \
+		usb_log_error(msg); \
+		if (!(allowed_failures-- > 0)) { \
+			usb_log_fatal( \
+			   "Maximum number of failures reached, " \
+			   "bailing out.\n"); \
+			return ret; \
+		} \
+		continue; \
+	} else (void)0
+
 	while (1) {
 		async_usleep(instance->wait_period_usec);
@@ -167,21 +183,15 @@
 		    instance->id_string, port_status);
 
+		int ret = usb_hc_connection_open(&instance->hc_connection);
+		CHECK_RET_FAIL(ret, "%s: Failed to connect to HC %s.\n",
+		    instance->id_string, str_error(ret));
+
 		/* Remove any old device */
-		if (instance->attached_device) {
-			usb_log_debug2("%s: Removing device.\n",
-			    instance->id_string);
+		if (instance->attached_device.fun) {
 			uhci_port_remove_device(instance);
 		}
 
-		int ret =
-		    usb_hc_connection_open(&instance->hc_connection);
-		if (ret != EOK) {
-			usb_log_error("%s: Failed to connect to HC.",
-			    instance->id_string);
-			continue;
-		}
-
 		if ((port_status & STATUS_CONNECTED) != 0) {
-			/* New device */
+			/* New device, this will take care of WC bits */
 			const usb_speed_t speed =
 			    ((port_status & STATUS_LOW_SPEED) != 0) ?
@@ -196,8 +206,6 @@
 
 		ret = usb_hc_connection_close(&instance->hc_connection);
-		if (ret != EOK) {
-			usb_log_error("%s: Failed to disconnect.",
-			    instance->id_string);
-		}
+		CHECK_RET_FAIL(ret, "%s: Failed to disconnect from hc: %s.\n",
+		    instance->id_string, str_error(ret));
 	}
 	return EOK;
@@ -212,5 +220,5 @@
  * Resets and enables the ub port.
  */
-int uhci_port_reset_enable(int portno, void *arg)
+int uhci_port_reset_enable(void *arg)
 {
 	uhci_port_t *port = arg;
@@ -256,11 +264,11 @@
 	usb_log_debug("%s: Detected new device.\n", port->id_string);
 
-	int ret, count = 0;
-	usb_address_t dev_addr;
+	int ret, count = MAX_ERROR_COUNT;
 	do {
 		ret = usb_hc_new_device_wrapper(port->rh, &port->hc_connection,
-		    speed, uhci_port_reset_enable, port->number, port,
-		    &dev_addr, &port->attached_device, NULL, NULL, NULL);
-	} while (ret != EOK && ++count < 4);
+		    speed, uhci_port_reset_enable, port,
+		    &port->attached_device.address, NULL, NULL,
+		    &port->attached_device.fun);
+	} while (ret != EOK && count-- > 0);
 
 	if (ret != EOK) {
@@ -271,6 +279,7 @@
 	}
 
-	usb_log_info("New device at port %u, address %d (handle %" PRIun ").\n",
-	    port->number, dev_addr, port->attached_device);
+	usb_log_info("%s: New device, address %d (handle %" PRIun ").\n",
+	    port->id_string, port->attached_device.address,
+	    port->attached_device.fun->handle);
 	return EOK;
 }
@@ -278,17 +287,42 @@
 /** Remove device.
  *
- * @param[in] port Memory structure to use.
- * @return Error code.
- *
- * Does not work, DDF does not support device removal.
- * Does not even free used USB address (it would be dangerous if tis driver
- * is still running).
+ * @param[in] port Port instance to use.
+ * @return Error code.
  */
 int uhci_port_remove_device(uhci_port_t *port)
 {
-	usb_log_error("%s: Don't know how to remove device %" PRIun ".\n",
-	    port->id_string, port->attached_device);
-	port->attached_device = 0;
-	return ENOTSUP;
+	assert(port);
+	/* There is nothing to remove. */
+	if (port->attached_device.fun == NULL) {
+		usb_log_warning("%s: Removed a ghost device.\n",
+		    port->id_string);
+		assert(port->attached_device.address == -1);
+		return EOK;
+	}
+
+	usb_log_debug("%s: Removing device.\n", port->id_string);
+
+	/* Stop driver first */
+	int ret = ddf_fun_unbind(port->attached_device.fun);
+	if (ret != EOK) {
+		usb_log_error("%s: Failed to remove child function: %s.\n",
+		   port->id_string, str_error(ret));
+		return ret;
+	}
+	ddf_fun_destroy(port->attached_device.fun);
+	port->attached_device.fun = NULL;
+
+	/* Driver stopped, free used address */
+	ret = usb_hc_unregister_device(&port->hc_connection,
+	    port->attached_device.address);
+	if (ret != EOK) {
+		usb_log_error("%s: Failed to unregister address of removed "
+		    "device: %s.\n", port->id_string, str_error(ret));
+		return ret;
+	}
+	port->attached_device.address = -1;
+
+	usb_log_info("%s: Removed attached device.\n", port->id_string);
+	return EOK;
 }
 /*----------------------------------------------------------------------------*/
Index: uspace/drv/bus/usb/uhcirh/port.h
===================================================================
--- uspace/drv/bus/usb/uhcirh/port.h	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/uhcirh/port.h	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -39,4 +39,5 @@
 #include <ddf/driver.h>
 #include <usb/hc.h> /* usb_hc_connection_t */
+#include <usb/dev/hub.h>
 
 typedef uint16_t port_status_t;
@@ -62,5 +63,5 @@
 	usb_hc_connection_t hc_connection;
 	ddf_dev_t *rh;
-	devman_handle_t attached_device;
+	usb_hub_attached_device_t attached_device;
 	fid_t checker;
 } uhci_port_t;
Index: uspace/drv/bus/usb/usbflbk/main.c
===================================================================
--- uspace/drv/bus/usb/usbflbk/main.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/usbflbk/main.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -46,5 +46,5 @@
  * @return Error code.
  */
-static int usbfallback_add_device(usb_device_t *dev)
+static int usbfallback_device_add(usb_device_t *dev)
 {
 	int rc;
@@ -64,4 +64,6 @@
 	}
 
+	dev->driver_data = ctl_fun;
+
 	usb_log_info("Pretending to control %s `%s'" \
 	    " (node `%s', handle %" PRIun ").\n",
@@ -72,11 +74,33 @@
 }
 
+/** Callback when new device is removed and recognized as gone by DDF.
+ *
+ * @param dev Representation of a generic DDF device.
+ * @return Error code.
+ */
+static int usbfallback_device_gone(usb_device_t *dev)
+{
+	assert(dev);
+	ddf_fun_t *ctl_fun = dev->driver_data;
+	const int ret = ddf_fun_unbind(ctl_fun);
+	if (ret != EOK) {
+		usb_log_error("Failed to unbind %s.\n", ctl_fun->name);
+		return ret;
+	}
+	ddf_fun_destroy(ctl_fun);
+	dev->driver_data = NULL;
+
+	return EOK;
+}
+
 /** USB fallback driver ops. */
-static usb_driver_ops_t usbfallback_driver_ops = {
-	.add_device = usbfallback_add_device,
+static const usb_driver_ops_t usbfallback_driver_ops = {
+	.device_add = usbfallback_device_add,
+	.device_rem = usbfallback_device_gone,
+	.device_gone = usbfallback_device_gone,
 };
 
 /** USB fallback driver. */
-static usb_driver_t usbfallback_driver = {
+static const usb_driver_t usbfallback_driver = {
 	.name = NAME,
 	.ops = &usbfallback_driver_ops,
Index: uspace/drv/bus/usb/usbhid/generic/hiddev.c
===================================================================
--- uspace/drv/bus/usb/usbhid/generic/hiddev.c	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/usbhid/generic/hiddev.c	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -48,8 +48,10 @@
 /*----------------------------------------------------------------------------*/
 
-usb_endpoint_description_t usb_hid_generic_poll_endpoint_description = {
+const usb_endpoint_description_t usb_hid_generic_poll_endpoint_description = {
 	.transfer_type = USB_TRANSFER_INTERRUPT,
 	.direction = USB_DIRECTION_IN,
 	.interface_class = USB_CLASS_HID,
+	.interface_subclass = -1,
+	.interface_protocol = -1,
 	.flags = 0
 };
@@ -59,19 +61,12 @@
 
 /*----------------------------------------------------------------------------*/
-
 static size_t usb_generic_hid_get_event_length(ddf_fun_t *fun);
-
-static int usb_generic_hid_get_event(ddf_fun_t *fun, uint8_t *buffer, 
+static int usb_generic_hid_get_event(ddf_fun_t *fun, uint8_t *buffer,
     size_t size, size_t *act_size, int *event_nr, unsigned int flags);
-
 static int usb_generic_hid_client_connected(ddf_fun_t *fun);
-
 static size_t usb_generic_get_report_descriptor_length(ddf_fun_t *fun);
-
-static int usb_generic_get_report_descriptor(ddf_fun_t *fun, uint8_t *desc, 
+static int usb_generic_get_report_descriptor(ddf_fun_t *fun, uint8_t *desc,
     size_t size, size_t *actual_size);
-
-/*----------------------------------------------------------------------------*/
-
+/*----------------------------------------------------------------------------*/
 static usbhid_iface_t usb_generic_iface = {
 	.get_event = usb_generic_hid_get_event,
@@ -80,36 +75,32 @@
 	.get_report_descriptor = usb_generic_get_report_descriptor
 };
-
+/*----------------------------------------------------------------------------*/
 static ddf_dev_ops_t usb_generic_hid_ops = {
 	.interfaces[USBHID_DEV_IFACE] = &usb_generic_iface,
 	.open = usb_generic_hid_client_connected
 };
-
-/*----------------------------------------------------------------------------*/
-
+/*----------------------------------------------------------------------------*/
 static size_t usb_generic_hid_get_event_length(ddf_fun_t *fun)
 {
 	usb_log_debug2("Generic HID: Get event length (fun: %p, "
 	    "fun->driver_data: %p.\n", fun, fun->driver_data);
-	
+
 	if (fun == NULL || fun->driver_data == NULL) {
 		return 0;
 	}
 
-	usb_hid_dev_t *hid_dev = (usb_hid_dev_t *)fun->driver_data;
-	
+	const usb_hid_dev_t *hid_dev = fun->driver_data;
+
 	usb_log_debug2("hid_dev: %p, Max input report size (%zu).\n",
 	    hid_dev, hid_dev->max_input_report_size);
-	
+
 	return hid_dev->max_input_report_size;
 }
-
-/*----------------------------------------------------------------------------*/
-
-static int usb_generic_hid_get_event(ddf_fun_t *fun, uint8_t *buffer, 
+/*----------------------------------------------------------------------------*/
+static int usb_generic_hid_get_event(ddf_fun_t *fun, uint8_t *buffer,
     size_t size, size_t *act_size, int *event_nr, unsigned int flags)
 {
 	usb_log_debug2("Generic HID: Get event.\n");
-	
+
 	if (fun == NULL || fun->driver_data == NULL || buffer == NULL
 	    || act_size == NULL || event_nr == NULL) {
@@ -118,68 +109,62 @@
 	}
 
-	usb_hid_dev_t *hid_dev = (usb_hid_dev_t *)fun->driver_data;
-	
+	const usb_hid_dev_t *hid_dev = (usb_hid_dev_t *)fun->driver_data;
+
 	if (hid_dev->input_report_size > size) {
-		usb_log_debug("input_report_size > size (%zu, %zu)\n", 
+		usb_log_debug("input_report_size > size (%zu, %zu)\n",
 		    hid_dev->input_report_size, size);
 		return EINVAL;	// TODO: other error code
 	}
-	
+
 	/*! @todo This should probably be somehow atomic. */
-	memcpy(buffer, hid_dev->input_report, 
+	memcpy(buffer, hid_dev->input_report,
 	    hid_dev->input_report_size);
 	*act_size = hid_dev->input_report_size;
 	*event_nr = usb_hid_report_number(hid_dev);
-	
+
 	usb_log_debug2("OK\n");
-	
-	return EOK;
-}
-
-/*----------------------------------------------------------------------------*/
-
+
+	return EOK;
+}
+/*----------------------------------------------------------------------------*/
 static size_t usb_generic_get_report_descriptor_length(ddf_fun_t *fun)
 {
 	usb_log_debug("Generic HID: Get report descriptor length.\n");
-	
+
 	if (fun == NULL || fun->driver_data == NULL) {
 		usb_log_debug("No function");
 		return EINVAL;
 	}
-	
-	usb_hid_dev_t *hid_dev = (usb_hid_dev_t *)fun->driver_data;
-	
-	usb_log_debug2("hid_dev->report_desc_size = %zu\n", 
+
+	const usb_hid_dev_t *hid_dev = fun->driver_data;
+
+	usb_log_debug2("hid_dev->report_desc_size = %zu\n",
 	    hid_dev->report_desc_size);
-	
+
 	return hid_dev->report_desc_size;
 }
-
-/*----------------------------------------------------------------------------*/
-
-static int usb_generic_get_report_descriptor(ddf_fun_t *fun, uint8_t *desc, 
+/*----------------------------------------------------------------------------*/
+static int usb_generic_get_report_descriptor(ddf_fun_t *fun, uint8_t *desc,
     size_t size, size_t *actual_size)
 {
 	usb_log_debug2("Generic HID: Get report descriptor.\n");
-	
+
 	if (fun == NULL || fun->driver_data == NULL) {
 		usb_log_debug("No function");
 		return EINVAL;
 	}
-	
-	usb_hid_dev_t *hid_dev = (usb_hid_dev_t *)fun->driver_data;
-	
+
+	const usb_hid_dev_t *hid_dev = fun->driver_data;
+
 	if (hid_dev->report_desc_size > size) {
 		return EINVAL;
 	}
-	
+
 	memcpy(desc, hid_dev->report_desc, hid_dev->report_desc_size);
 	*actual_size = hid_dev->report_desc_size;
-	
-	return EOK;
-}
-
-/*----------------------------------------------------------------------------*/
-
+
+	return EOK;
+}
+/*----------------------------------------------------------------------------*/
 static int usb_generic_hid_client_connected(ddf_fun_t *fun)
 {
@@ -187,11 +172,29 @@
 	return EOK;
 }
-
-/*----------------------------------------------------------------------------*/
-
-static int usb_generic_hid_create_function(usb_hid_dev_t *hid_dev)
-{	
+/*----------------------------------------------------------------------------*/
+void usb_generic_hid_deinit(usb_hid_dev_t *hid_dev, void *data)
+{
+	ddf_fun_t *fun = data;
+	if (fun == NULL)
+		return;
+
+	if (ddf_fun_unbind(fun) != EOK) {
+		usb_log_error("Failed to unbind generic hid fun.\n");
+		return;
+	}
+	usb_log_debug2("%s unbound.\n", fun->name);
+	/* We did not allocate this, so leave this alone
+	 * the device would take care of it */
+	fun->driver_data = NULL;
+	ddf_fun_destroy(fun);
+}
+/*----------------------------------------------------------------------------*/
+int usb_generic_hid_init(usb_hid_dev_t *hid_dev, void **data)
+{
+	if (hid_dev == NULL) {
+		return EINVAL;
+	}
+
 	/* Create the exposed function. */
-	/** @todo Generate numbers for the devices? */
 	usb_log_debug("Creating DDF function %s...\n", HID_GENERIC_FUN_NAME);
 	ddf_fun_t *fun = ddf_fun_create(hid_dev->usb_dev->ddf_dev, fun_exposed, 
@@ -201,7 +204,9 @@
 		return ENOMEM;
 	}
-	
+
+	/* This is nasty, both device and this function have the same
+	 * driver data, thus destruction causes to double free */
+	fun->driver_data = hid_dev;
 	fun->ops = &usb_generic_hid_ops;
-	fun->driver_data = hid_dev;
 
 	int rc = ddf_fun_bind(fun);
@@ -209,31 +214,19 @@
 		usb_log_error("Could not bind DDF function: %s.\n",
 		    str_error(rc));
+		fun->driver_data = NULL;
 		ddf_fun_destroy(fun);
 		return rc;
 	}
-	
+
 	usb_log_debug("HID function created. Handle: %" PRIun "\n", fun->handle);
-	
-	return EOK;
-}
-
-/*----------------------------------------------------------------------------*/
-
-int usb_generic_hid_init(usb_hid_dev_t *hid_dev, void **data)
-{
-	if (hid_dev == NULL) {
-		return EINVAL;
-	}
-	
-	return usb_generic_hid_create_function(hid_dev);
-}
-
-/*----------------------------------------------------------------------------*/
-
+	*data = fun;
+
+	return EOK;
+}
+/*----------------------------------------------------------------------------*/
 bool usb_generic_hid_polling_callback(usb_hid_dev_t *hid_dev, void *data)
 {
 	return true;
 }
-
 /**
  * @}
Index: uspace/drv/bus/usb/usbhid/generic/hiddev.h
===================================================================
--- uspace/drv/bus/usb/usbhid/generic/hiddev.h	(revision a52de0ea49d86563c5209f5780a0c9d431c14235)
+++ uspace/drv/bus/usb/usbhid/generic/hiddev.h	(revision c8c43caeaf653de4af38ee1f5fbcddf8d9850cdd)
@@ -41,5 +41,6 @@
 struct usb_hid_dev;
 
-usb_endpoint_description_t usb_hid_generic_poll_endpoint_description;
+extern const usb_endpoint_description_t
+    usb_hid_generic_poll_endpoint_description;
 
 const char *HID_GENERIC_FUN_NAME;
@@ -50,4 +51,6 @@
 int usb_generic_hid_init(struct usb_hid_dev *hid_dev, void **data);
 
+void usb_generic_hid_deinit(struct usb_hid_dev *hid_dev, void *data);
+
 bool usb_generic_hid_polling_callback(struct usb_hid_dev *hid_dev, void *data);
 
